"""
Author: Jun Ding
Date: May 31, 2011
Version: 1.1
Function: This code is used to get the Cis-regulatory modules for given sequences.
Usage: python crm.py <input_seq_file><input_motif_file><cutoff><redundant_motif_cutoff><support_value><output_folder_name>
"""
import sys,pdb,os
sys.path.append('code')
import Motif,rmRepeat
from Motif import *
from rmRepeat import *
os.system("echo 'begin scanning sequences'")
os.system("python code/Motif.py -m 2 "+sys.argv[1]+" "+sys.argv[2]+" "+sys.argv[3])
os.system("echo 'removing redundant motif hits...'")
os.system("python code/Motif.py -m 4 "+sys.argv[2]+" "+"MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+" "+"MotifHitsPositions_"+sys.argv[1]+"_"+sys.argv[2]+" "+sys.argv[4])
os.remove("MotifHits_"+sys.argv[1]+"_"+sys.argv[2])
os.remove("MotifHitsPositions_"+sys.argv[1]+"_"+sys.argv[2])
os.system("python code/rmRepeat.py "+"non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4])
os.system("chmod +x code/fim_maximal")
os.system("echo 'generating candidate motif modules...'")
trans="Transaction_non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4]
os.system("./code/fim_maximal "+trans+" "+sys.argv[5]+" candidate_modules")
os.system("echo 'statistical evaluation...'")

os.system("python code/SEQProcess.py -m 1 "+sys.argv[1])
os.system("python code/Motif.py -m 2 "+"randomPermuted_"+sys.argv[1]+" "+sys.argv[2]+" "+sys.argv[3])
os.system("python code/getLambda.py "+"MotifHits_randomPermuted_"+sys.argv[1]+"_"+sys.argv[2]+" "+sys.argv[1]+" "+sys.argv[2])
os.system("python code/pgc.py candidate_modules "+"lambda_"+sys.argv[2]+" "+sys.argv[2]+" "+sys.argv[1])
os.remove("lambda_"+sys.argv[2])
os.remove("Transaction_"+"non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4])
os.remove("candidate_modules")
try:
	os.system("mkdir "+sys.argv[6])
except:
	pass
command="cp "+"non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4]+" "+sys.argv[6]+"/non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4]
command1="cp "+"non_redundant_MotifHitsPositions_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4]+" "+sys.argv[6]+"/non_redundant_MotifHitsPositions_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4]
command2="cp "+"significant_candidate_modules"+" "+sys.argv[6]+"/significant_modules"
command3="cp "+"corrected_pvalue_candidate_modules"+" "+sys.argv[6]+"/corrected_pvalue_significant_modules"
os.system(command)
os.system(command1)
os.system(command2)
os.system(command3)
os.remove("non_redundant_MotifHits_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4])
os.remove("non_redundant_MotifHitsPositions_"+sys.argv[1]+"_"+sys.argv[2]+"_"+sys.argv[4])
os.remove("significant_candidate_modules")
os.remove("corrected_pvalue_candidate_modules")
os.remove("MotifHits_randomPermuted_"+sys.argv[1]+"_"+sys.argv[2])
os.remove("MotifHitsPositions_randomPermuted_"+sys.argv[1]+"_"+sys.argv[2])
os.remove("randomPermuted_"+sys.argv[1])
os.system("python code/sig_module_pvalue.py "+sys.argv[6]+"/significant_modules  "+sys.argv[6]+"/corrected_pvalue_significant_modules")
os.remove(sys.argv[6]+"/corrected_pvalue_significant_modules")
os.system("cp significant_modules "+sys.argv[6]+"/significant_modules")
os.remove("significant_modules")





